﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using System.Net;
using System.Data;
using System.Net.Mail;
using System.Configuration;
using System.Data.SqlClient;
using CrystalDecisions.Shared;
using CrystalDecisions.CrystalReports.Engine;

public partial class CS : System.Web.UI.Page
{
    ReportDocument crystalReport;
    protected void Page_Load(object sender, EventArgs e)
    {
        crystalReport = new ReportDocument();
        crystalReport.Load(Server.MapPath("~/CustomerReport.rpt"));
        Customers dsCustomers = this.GetData("SELECT TOP 5 * FROM customers");
        crystalReport.SetDataSource(dsCustomers);
        CrystalReportViewer1.ReportSource = crystalReport;
    }

    private Customers GetData(string query)
    {
        string conString = ConfigurationManager.ConnectionStrings["constr"].ConnectionString;
        SqlCommand cmd = new SqlCommand(query);
        using (SqlConnection con = new SqlConnection(conString))
        {
            using (SqlDataAdapter sda = new SqlDataAdapter())
            {
                cmd.Connection = con;

                sda.SelectCommand = cmd;
                using (Customers dsCustomers = new Customers())
                {
                    sda.Fill(dsCustomers, "DataTable1");
                    return dsCustomers;
                }
            }
        }
    }

    protected void SendEmail(object sender, EventArgs e)
    {
        using (MailMessage mm = new MailMessage("sender@gmail.com", "recipient@gmail.com"))
        {
            mm.Subject = "Crystal Report PDF";
            mm.Body = "Attachment: Customer's Crystal Report PDF";
            mm.Attachments.Add(new Attachment(crystalReport.ExportToStream(ExportFormatType.PortableDocFormat), "Crystal.pdf"));
            mm.IsBodyHtml = true;
            using (SmtpClient smtp = new SmtpClient())
            {
                smtp.Host = "smtp.gmail.com";
                smtp.UseDefaultCredentials = true;
                smtp.Credentials = new NetworkCredential
                {
                    UserName = "sender@gmail.com",
                    Password = "xxxx"
                };
                smtp.Port = 587;
                smtp.EnableSsl = true;
                smtp.Send(mm);
            }
        }
    }
}